{

open messagebases
(c) 1999-2000 by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

13/12/99   + KillBase
26/01/00    small correctives
17/04/00   + BaseNameByExt
24/04/00   + CopyBase

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rOpen;
interface
Uses rAbs;
{}
const
{}
 MsgMask     : pChar = '*.msg';
 PktExt      : pChar = '.pkt';
 PktLetter   : Char  = 'P';
 SquLetter   : Char  = 'S';
 JamLetter   : Char  = 'J';
 MsgLetter   : Char  = 'F';
 msgLastRead : pChar = 'lastread';
{}
{
f,# - msg;
p   - pkt;
s,$ - squish;
j,! - jam;
}
{}
 function  CreateBase(Name: String; aShareMode: Word): pAbsBase;
 function  OpenOrCreateBase(Name: String; aShareMode: Word): pAbsBase;
 function  KillBase(Name: String): Byte;
 function  KillLastRead(Name: String): Byte;
 function  BaseNameByExt(Name: String): String;
 procedure CopyBase(SourceBase, DestinationDir: String);
{}
implementation
Uses Strings, rFidoMsg, rSquish, rJam, rObjects, rStrings, rCommon, Dos;
{}
function    BaseNameByExt(Name: String): String;
 var
  c: Char;
 begin
  BaseNameByExt:='';
  if Name='' then exit;
  if not (UpCase(Name[1]) in [PktLetter,MsgLetter,SquLetter,JamLetter,Lattice,Bucks,Excl]) then
   begin
    if (Point+UpStr(JustExtension(Name))=UpStr(JamHdrExt)) or
       (Point+UpStr(JustExtension(Name))=UpStr(JamTextExt)) or
       (Point+UpStr(JustExtension(Name))=UpStr(JamIndexExt)) then Name:=Excl+Name else
    if (Point+UpStr(JustExtension(Name))=UpStr(SqDataExt)) or
       (Point+UpStr(JustExtension(Name))=UpStr(SqIndexExt)) then Name:=Bucks+Name else
    if (JustExtension(Name)='') then Name:=Lattice+Name else
    if (Point+UpStr(JustExtension(Name))=UpStr(StrPas(PktExt))) then Name:=PktLetter+Name;
   end;
  if (Point+UpStr(JustExtension(Name))=UpStr(JamHdrExt)) or
     (Point+UpStr(JustExtension(Name))=UpStr(JamTextExt)) or
     (Point+UpStr(JustExtension(Name))=UpStr(JamIndexExt)) or
     (Point+UpStr(JustExtension(Name))=UpStr(SqDataExt)) or
     (Point+UpStr(JustExtension(Name))=UpStr(SqIndexExt)) then Name:=AddBackSlash(JustPathName(Name))+JustName(Name);
  c:=UpCase(Name[1]);
  if (c in [Lattice,MsgLetter]) then Name:=AddBackSlash(Name)+StrPas(MsgMask) else
  if (c in [PktLetter]) then Name:=AddBackSlash(JustPathName(Name))+JustFileName(Name) else
  if (c in [SquLetter,Bucks]) then Name:=AddBackSlash(JustPathName(Name))+JustFileName(Name) else
  if (c in [JamLetter,Excl]) then Name:=AddBackSlash(JustPathName(Name))+JustFileName(Name);
  BaseNameByExt:=Name;
 end;
{}
function    CreateBase(Name: String; aShareMode: Word): pAbsBase;
 var
  c: Char;
  Base: pAbsBase;
  sr: SearchRec;
  r: Byte;
 begin
  Base:=nil;
  CreateBase:=nil;
  if Name='' then exit;
  Name:=BaseNameByExt(Name);
  KillBase(Name);
  c:=UpCase(Name[1]);
  NewDelete(Name,1,1);
  if (c in [Lattice,MsgLetter]) then Base:=New(pMsgBase,Init) else
  if (c in [PktLetter]) then Base:=New(pPktBase,Init) else
  if (c in [SquLetter,Bucks]) then Base:=New(pSquishBase,Init) else
  if (c in [JamLetter,Excl]) then Base:=New(pJamBase,Init);
  r:=Base^.SaveBaseHdr(Name,aShareMode);
  if (Base^.BaseStatus<>bsOpened) or (r<>0) then DisposeObj(Base);
  CreateBase:=Base;
 end;
{}
function    OpenOrCreateBase(Name: String; aShareMode: Word): pAbsBase;
 var
  c: Char;
  Base: pAbsBase;
  r: Byte;
 begin
  Base:=nil;
  OpenOrCreateBase:=nil;
  if (Length(Name) in [0,1]) then exit;
  Name:=BaseNameByExt(Name);
  c:=UpCase(Name[1]);
  NewDelete(Name,1,1);
  r:=1;
  if (c in [MsgLetter,Lattice]) then Base:=New(pMsgBase,Init) else
  if (c in [PktLetter]) then Base:=New(pPktBase,Init) else
  if (c in [SquLetter,Bucks]) then Base:=New(pSquishBase,Init) else
  if (c in [JamLetter,Excl]) then Base:=New(pJamBase,Init);
  r:=Base^.LoadBaseHdr(Name,aShareMode);
  if (Base^.BaseStatus<>bsOpened) or (r<>0) then r:=Base^.SaveBaseHdr(Name,aShareMode);
  if r<>0 then
   begin
    DisposeObj(Base);
    OpenOrCreateBase:=nil;
   end
  else OpenOrCreateBase:=Base;
 end;
{}
function KillBase(Name: String): Byte;
 var
  c: Char;
  sr: SearchRec;
 begin
  KillBase:=1;
  if Name='' then exit;
  Name:=BaseNameByExt(Name);
  c:=UpCase(Name[1]);
  NewDelete(Name,1,1);
  if (c in [MsgLetter,Lattice]) then if DExist(JustPathName(Name)) then
   begin
    FindFirst(Name,AnyFile,sr);
    while DosError=0 do
     begin
      if (UpStr(JustExtension(sr.Name))='MSG') then KillFile(AddBackSlash(JustPathName(Name))+sr.Name);
      FindNext(sr);
     end;
   end else
  if (c in [PktLetter]) then KillFile(Name) else
  if (c in [SquLetter,Bucks]) then
   begin
    KillFile(Name+SqDataExt);
    KillFile(Name+SqIndexExt);
   end else
  if (c in [JamLetter,Excl]) then
   begin
    KillFile(Name+JamHdrExt);
    KillFile(Name+JamTextExt);
    KillFile(Name+JamIndexExt);
   end;
  KillBase:=0;
 end;
{}
function KillLastRead;
 var
  c: Char;
 begin
  KillLastRead:=1;
  if Name='' then exit;
  Name:=BaseNameByExt(Name);
  c:=UpCase(Name[1]);
  NewDelete(Name,1,1);
  if (c in [MsgLetter,Lattice]) then KillFile(AddBackSlash(Name)+StrPas(msgLastRead));
  if (c in [SquLetter,Bucks]) then KillFile(Name+SqLastReadExt);
  if (c in [JamLetter,Excl]) then KillFile(Name+JamLastReadExt);
  KillLastRead:=0;
 end;
{}
procedure  CopyBase(SourceBase, DestinationDir: String);
 var
  c: Char;
 begin
  if SourceBase='' then exit;
  DestinationDir:=AddBackSlash(DestinationDir);
  if not mkTree(DestinationDir) then exit;
  SourceBase:=BaseNameByExt(SourceBase);
  c:=UpCase(SourceBase[1]);
  NewDelete(SourceBase,1,1);
  if (c in [MsgLetter,Lattice]) then if DExist(RemoveBackSlash(SourceBase)) then
  CopyDir(AddBackSlash(SourceBase),DestinationDir,false) else
  if (c in [PktLetter]) then
   begin
    SourceBase:=AddBackSlash(JustPathName(SourceBase))+JustName(SourceBase);
    CopyFile(SourceBase,DestinationDir+JustFileName(SourceBase),false);
   end else
  if (c in [SquLetter,Bucks]) then
   begin
    SourceBase:=AddBackSlash(JustPathName(SourceBase))+JustName(SourceBase);
    CopyFile(SourceBase+SqDataExt,DestinationDir+JustFileName(SourceBase)+SqDataExt,false);
    CopyFile(SourceBase+SqIndexExt,DestinationDir+JustFileName(SourceBase)+SqIndexExt,false);
   end else
  if (c in [JamLetter,Excl]) then
   begin
    SourceBase:=AddBackSlash(JustPathName(SourceBase))+JustName(SourceBase);
    CopyFile(SourceBase+JamHdrExt,DestinationDir+JustFileName(SourceBase)+JamHdrExt,false);
    CopyFile(SourceBase+JamTextExt,DestinationDir+JustFileName(SourceBase)+JamTextExt,false);
    CopyFile(SourceBase+JamIndexExt,DestinationDir+JustFileName(SourceBase)+JamIndexExt,false);
   end;
 end;
end.
